<?php
/*
Plugin Name: Smilies Themer Toolbar
Plugin URI: http://polpoinodroidi.netsons.org/wordpress-plugins/smilies-themer-toolbar/
Description: Adds a toolbar to easily add to comments your smilies managed by <a href='http://wordpress.org/extend/plugins/smilies-themer/'>Smilies Themer</a> plugin.
Version: 0.4.2
Author: Frasten
Author URI: http://polpoinodroidi.netsons.org
*/

/* Todo:
 * - Configuration page: pre/after bar; max number of smilies;
 * 
 * Later:
 * - tinyMCE admin page integration
 * - configurable smilies order, with drag & drop
 * 
 * 
 * Known issues:
 * 
 * */

class SmiliesThemerToolbar {
	var $is_shown = false;
	
	function showToolBar() {
		global $smilies_themer;
		// Check if Smilies Themer plugin is installed and running
		if (!$smilies_themer) return;
		if (!$smilies_themer->use_smilies) return;
		
		// Check if the toolbar was alread shown via direct calling in themes
		if ($this->is_shown) return;
		
		$path = $smilies_themer->smilies->url_path;
		
		// I discard smilies containing quotes, they don't work. (WP limitation)
		$sm = array();
		foreach ($smilies_themer->smilies->smilies as $key => $value) {
			if (strpos($key,"'")) continue;
			$sm[$key] = $value;
		}
		
		// Discard duplicates		
		$sm = array_reverse($sm);
		$sm = array_flip($sm);
		$sm = array_reverse($sm);
		
		$this->print_js();
		
		echo "<div id='smilies_toolbar'>\n";
		foreach ($sm as $image => $text) {
			echo "<img src='$path/$image'";
			echo " class='wp-smiley'";
			echo " alt='".htmlentities($text,ENT_QUOTES)."'";
			echo " onclick='addSmiley(\"".htmlentities($text,ENT_QUOTES)."\")' />\n";
		}
		echo "</div>\n";
		$this->is_shown = true;
	}
	
	function print_js() {
		?>
		<script type='text/javascript'>
			var stt_comment_field;
		
			function findCommentFieldName() {
				var re = /wp-comments-post\.php$/;
				
				for (i = 0;i < document.forms.length;i++) {
					var theForm = document.forms[i];
					var action = theForm.action
					if (re.test(action)) {
						stt_comment_field = theForm.elements['comment'].id;
						return;
					}
				}
			}
			
			function addSmiley(sm) {
				var area = document.getElementById(stt_comment_field);
				if (!area) return;
				var pre, pre, selStart,selEnd;
				area.focus();

				if (document.selection && !window.opera) {
					// I REALLY HATE Internet Explorer!!!!!
					var sel = document.selection.createRange();
					var sel2 = sel.duplicate();
					sel2.moveToElementText(area);
					sel2.setEndPoint('StartToEnd', sel);
					selEnd = area.value.length-sel2.text.length;
					sel2.setEndPoint('StartToStart', sel);
					selStart = area.value.length-sel.text.length;
					pre = area.value.substring(0,selStart);
					
					sm = spaceSmiley(sm,pre);
					sel.text = sm;
				}
				else {
					selStart = area.selectionStart;
					selEnd = area.selectionEnd;
					var testo = area.value;
					pre = testo.substring(0,selStart);
					post = testo.substring(selEnd);
					// if the character before the smiley is not a space, let's
					// add one before it. And add a space to the end.
					sm = spaceSmiley(sm, pre);
					
					var risultato = pre+sm+post;
					area.value = risultato;
				}
				
				area.selectionEnd = area.selectionStart = selStart + sm.length;
			}

			function spaceSmiley(sm,pre) {
				// Add one ending space, always.
				sm = sm + ' ';

				var lastPreSmileyChar = pre.substr(pre.length - 1, 1);
				if (lastPreSmileyChar && lastPreSmileyChar != ' '
					&& lastPreSmileyChar.charCodeAt(0) != 10
					&& lastPreSmileyChar.charCodeAt(0) != 13) {
					sm = ' '+sm;
				}
				return sm;
			}
			
			function onContent(f){//(C)webreflection.blogspot.com
				var a=onContent,b=navigator.userAgent,d=document,w=window,c="onContent",e="addEventListener",o="opera",r="readyState",
				s="<scr".concat("ipt defer src='//:' on",r,"change='if(this.",r,"==\"complete\"){this.parentNode.removeChild(this);",c,".",c,"()}'></scr","ipt>");
				a[c]=(function(o){return function(){a[c]=function(){};for(a=arguments.callee;!a.done;a.done=1)f(o?o():o)}})(a[c]);
				if(d[e])d[e]("DOMContentLoaded",a[c],false);
				if(/WebKit|Khtml/i.test(b)||(w[o]&&parseInt(w[o].version())<9))(function(){/loaded|complete/.test(d[r])?a[c]():setTimeout(arguments.callee,1)})();
				else if(/MSIE/i.test(b))d.write(s);
			};
			
			
			onContent(findCommentFieldName);
		</script><?php
	}
	
	function print_css() {
		 echo "
        <style type='text/css'>
          #smilies_toolbar .wp-smiley {
            cursor: pointer;
          }
        </style>
        ";
	}
}

function sm_toolbar_show() {
	global $sm_toolbar;
	if ($sm_toolbar && method_exists($sm_toolbar,'showToolBar'))
		$sm_toolbar->showToolBar();
}



$sm_toolbar = new SmiliesThemerToolbar();

// If it was already shown through theme calling, this is overridden.
add_action('comment_form', array(&$sm_toolbar, 'showToolBar'));

add_action('wp_head', array(&$sm_toolbar, 'print_css'));


?>
